import React, { useState } from "react";
import Head from "next/head";
import ProfileLayout from "@/components/modules/profileLayout";
import NoProfileMenuData from "@/components/modules/noProfileMenuData";
import MyeSIMDetails from "@/components/rendering/profilePageSections/myEsimDetails";
import { parseCookies } from "nookies";
import { getESimList } from "@/utils/api/auth";

export default function MyESimPage({ eSimListRes, iccid }: any) {
  const [eSimList, setESimList] = useState(eSimListRes);

  return (
    <>
      <Head>
        <title>WaoSim | My eSIM</title>
        <meta name="description" content="Generated by create next app" />
        <meta name="viewport" content="width=device-width, initial-scale=1" />
        <link rel="icon" href="/faviconIcon.svg" />
      </Head>
      <main>
        <ProfileLayout>
          {eSimList?.length > 0 ? (
            <MyeSIMDetails
              eSimList={eSimList}
              setESimList={setESimList}
              iccid={iccid}
            />
          ) : (
            <NoProfileMenuData
              mainTitle={`My eSIM`}
              backgroundImage={
                "https://stagecdn.waosim.com/myprofile/nomyEsimCardImage.png"
              }
              buttonTitle={`Explore Plans`}
              buttonLink={`/plans`}
            />
          )}
        </ProfileLayout>{" "}
      </main>
    </>
  );
}

export async function getServerSideProps(context: any) {
  const { req, query } = context;
  const cookies = parseCookies({ req });

  const { iccid } = query;

  if (!cookies?.waotoken) {
    return {
      redirect: {
        destination: "/auth/login",
        permanent: false,
      },
    };
  }

  let payload = {
    waotoken: cookies?.waotoken,
    is_setting: 1,
  };

  const { isError, response } = await getESimList(payload);

  return {
    props: {
      eSimListRes: response?.data?.length > 0 ? response?.data : null,
      iccid: iccid ?? null,
    },
  };
}
